VERSION 5.00
Begin VB.Form Main 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Bot Generator"
   ClientHeight    =   3810
   ClientLeft      =   45
   ClientTop       =   405
   ClientWidth     =   3705
   Icon            =   "Main.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   3810
   ScaleWidth      =   3705
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox NameTxt 
      Height          =   285
      Left            =   1440
      TabIndex        =   4
      Text            =   "Name"
      ToolTipText     =   "Enter the name you want your bot to have here"
      Top             =   560
      Width           =   1095
   End
   Begin VB.CommandButton testDecode 
      Caption         =   "Command1"
      Enabled         =   0   'False
      Height          =   375
      Left            =   3600
      TabIndex        =   8
      Top             =   3120
      Visible         =   0   'False
      Width           =   975
   End
   Begin VB.TextBox pathText 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      Height          =   485
      Left            =   120
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   1  'Horizontal
      TabIndex        =   2
      ToolTipText     =   "The currently selected directory is shown here"
      Top             =   2680
      Width           =   3495
   End
   Begin VB.ComboBox botNum 
      Height          =   315
      ItemData        =   "Main.frx":57E2
      Left            =   1440
      List            =   "Main.frx":57E4
      TabIndex        =   5
      Text            =   "Bot #"
      ToolTipText     =   "Enter the number of the bot here (corresponds to that selected in FLMM)"
      Top             =   820
      Width           =   1095
   End
   Begin VB.CommandButton GenButton 
      Caption         =   "Generate"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   2640
      TabIndex        =   0
      ToolTipText     =   "Generate the bot!"
      Top             =   600
      Width           =   975
   End
   Begin VB.CommandButton setDir 
      Caption         =   "Choose a new directory"
      Enabled         =   0   'False
      Height          =   495
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "Select a new directory to look for character files in; also looks in all subdirectories"
      Top             =   600
      Width           =   1215
   End
   Begin VB.ListBox List1 
      Height          =   1425
      ItemData        =   "Main.frx":57E6
      Left            =   120
      List            =   "Main.frx":57E8
      TabIndex        =   1
      ToolTipText     =   "Select the character to make the bot from here"
      Top             =   1200
      Width           =   3495
   End
   Begin VB.Label statusText 
      BorderStyle     =   1  'Fixed Single
      Height          =   495
      Left            =   120
      TabIndex        =   7
      ToolTipText     =   "Status"
      Top             =   3240
      Width           =   3495
   End
   Begin VB.Label Title 
      Alignment       =   2  'Center
      Caption         =   "88 Flak Bot Generator"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   6
      ToolTipText     =   "Programmed by M0tah"
      Top             =   120
      Width           =   3495
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Text

Dim fileName As String

'Folder Constants
Private Const CSIDL_PERSONAL = &H5                'My Documents

'Converts an item identifier list to a file system path.
Private Declare Function SHGetPathFromIDList Lib "shell32" _
   Alias "SHGetPathFromIDListA" _
  (ByVal pidl As Long, _
   ByVal pszPath As String) As Long

Private Declare Function SHGetSpecialFolderLocation Lib "shell32" _
   (ByVal hWndOwner As Long, _
    ByVal nFolder As Long, _
    pidl As Long) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" _
   (ByVal pv As Long)

Private Const MAX_PATH As Long = 260
Private Const S_OK As Long = 0

'Char file
Private Type charFile
    Name As String
    Path As String
End Type
Dim chars() As charFile

Dim paintTimes As Byte
   
Private Sub Form_Paint()
    If paintTimes Then Exit Sub 'Not first time painting GUI, do not search for chars
    paintTimes = paintTimes + 1
    statusText.Caption = "Loading..."
    botNum.AddItem ("1")
    botNum.AddItem ("2")
    botNum.AddItem ("3")
    botNum.AddItem ("4")
    pathText.Text = GetSpecialFolderLocation(CSIDL_PERSONAL) & "\My Games\Freelancer\Accts\MultiPlayer"
    If Dir(pathText.Text, vbDirectory) = "" Then pathText.Text = GetFolder(Me.hWnd, "Unable to find Freelancer saved game folder")
    If pathText.Text = "" Then End 'User pressed cancel
    
    Dim subFolders As Variant
    statusText.Caption = "Looking for subfolders in " & pathText.Text
    DoEvents
    subFolders = getSubFolders(pathText.Text)
    ReDim Preserve subFolders(LBound(subFolders) To UBound(subFolders) + 1)
    subFolders(UBound(subFolders)) = pathText.Text
    Dim i As Integer
    For i = LBound(subFolders) To UBound(subFolders)
        Dim status As String
        status = Replace(subFolders(i), pathText.Text, "")
        If status = "" Then status = "root directory"
        statusText.Caption = "Looking for character files in " & status
        DoEvents
        Dim charPath As String
        charPath = Dir(subFolders(i) & "\*.fl", vbReadOnly)
        Do While charPath <> ""
            Dim char As charFile
            char.Path = subFolders(i) & "\" & charPath
            char.Name = getCharName(char.Path)
            If char.Name <> "" Then
                If (Not chars) = -1 Then
                    ReDim chars(0 To 0)
                Else
                    ReDim Preserve chars(LBound(chars) To UBound(chars) + 1)
                End If
                chars(UBound(chars)) = char
            End If
            charPath = Dir
        Loop
    Next i
    
    If (Not chars) <> -1 Then
        For i = LBound(chars) To UBound(chars)
            List1.AddItem (chars(i).Name)
        Next i
    End If
    setDir.Enabled = True
    statusText.Caption = "Ready"
End Sub

Public Function getSubFolders(folderPath As String) As Variant
    Dim getFolders As Variant
    getFolders = Array()
    
    Dim fs, f, f1, sf
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(folderPath)
    Set sf = f.subFolders
    For Each f1 In sf
        ReDim Preserve getFolders(0 To UBound(getFolders) + 1)
        getFolders(UBound(getFolders)) = folderPath & "\" & f1.Name
        addSubFolders folderPath & "\" & f1.Name, getFolders
    Next
    Set fs = Nothing
    Set f = Nothing
    Set sf = Nothing

    DoEvents
    getSubFolders = getFolders
End Function

'Recursively called function, adds subfolders of folderPath to folderArray
Private Function addSubFolders(folderPath As String, ByRef folderArray As Variant)
    Dim fs, f, f1, sf
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set f = fs.GetFolder(folderPath)
    Set sf = f.subFolders
    For Each f1 In sf
        ReDim Preserve folderArray(0 To UBound(folderArray) + 1)
        folderArray(UBound(folderArray)) = folderPath & "\" & f1.Name
        addSubFolders folderPath & "\" & f1.Name, folderArray
    Next
    Set fs = Nothing
    Set f = Nothing
    Set sf = Nothing
    DoEvents
End Function
'                                             String (Variant)
Private Function getCharName(playerFilePath As Variant) As String 'Gets the name of the character given the path to a .fl save file
    Dim inFile As String, playerName As String
    FLCDecode CStr(playerFilePath), inFile
    If LenB(inFile) = 0 Then
        MsgBox "Could not decode file " & playerFilePath, vbExclamation
        Exit Function
    End If
    Dim fileLocation, i As Integer
    fileLocation = InStr(inFile, "name = ")
    If fileLocation = 0 Then
        MsgBox "Could not decode file " & playerFilePath, vbExclamation
        Exit Function
    End If
    playerName = Mid(inFile, fileLocation + 7, InStr(fileLocation, inFile, vbLf) - (fileLocation + 7))
    For i = 1 To Len(playerName) Step 4
        Dim hexStr As String
        hexStr = Mid(playerName, i, 4)
        getCharName = getCharName & Chr(Val("&H" & hexStr))
    Next i
End Function

Private Function processFile(playerFilePath As String)
    GenButton.Enabled = False
    botNum.Enabled = False
    setDir.Enabled = False
    NameTxt.Enabled = False
    List1.Enabled = False
    DoEvents
    
    Dim inFile As String
    Dim playerFile() As String
    FLCDecode playerFilePath, inFile
    If LenB(inFile) = 0 Then
        MsgBox "Could not decode file " & playerFilePath, vbCritical
        Exit Function
    End If
    DoEvents
    Dim fs, file
    Set fs = CreateObject("Scripting.FileSystemObject")
    playerFile = Split(inFile, vbLf)
    Dim rank As String, ship_archetype As String
    Dim equip As Variant, cargo As Variant
    equip = Array()
    cargo = Array()
    Dim i As Long, j As Long
    
    statusText.Caption = statusText.Caption & "."
    DoEvents
    
    For i = LBound(playerFile) To UBound(playerFile) 'Collect information from file
        If InStr(playerFile(i), "last_base") <> 0 Then Exit For
        If InStr(playerFile(i), "equip") <> 0 Then
            ReDim Preserve equip(0 To UBound(equip) + 1)
            equip(UBound(equip)) = playerFile(i)
        Else
            If InStr(playerFile(i), "cargo") <> 0 Then
                ReDim Preserve cargo(0 To UBound(cargo) + 1)
                cargo(UBound(cargo)) = playerFile(i)
            Else
                If InStr(playerFile(i), "rank") <> 0 Then
                    rank = playerFile(i)
                Else
                    If InStr(playerFile(i), "ship_archetype") <> 0 Then ship_archetype = playerFile(i)
                End If
            End If
        End If
    Next i
    
    statusText.Caption = statusText.Caption & "."
    DoEvents
    
    For i = LBound(equip) To UBound(equip) 'Process equipment definitions, remove stuff
        Dim equipSplit() As String
        equipSplit = Split(equip(i), ",")
        equip(i) = ""
        For j = LBound(equipSplit) To UBound(equipSplit)
            equipSplit(j) = Trim$(equipSplit(j))
            If LenB(equipSplit(j)) <> 0 And equipSplit(j) <> "1" Then
                If LenB(equip(i)) = 0 Then
                    equip(i) = equipSplit(j)
                Else
                    equip(i) = equip(i) & ", " & equipSplit(j)
                End If
            End If
        Next j
        equip(i) = Trim$(equip(i))
    Next i
    
    statusText.Caption = statusText.Caption & "."
    DoEvents
    
    For i = LBound(cargo) To UBound(cargo) 'Process cargo definitions, remove stuff
        Dim cargoSplit As Variant
        cargoSplit = Split(cargo(i), ",")
        cargo(i) = ""
        For j = LBound(cargoSplit) To UBound(cargoSplit)
            cargoSplit(j) = Trim$(cargoSplit(j))
            If LenB(cargoSplit(j)) <> 0 And cargoSplit(j) <> "0" Then
                If LenB(cargo(i)) = 0 Then
                    cargo(i) = cargoSplit(j)
                Else
                    cargo(i) = cargo(i) & ", " & cargoSplit(j)
                End If
            End If
        Next j
        cargo(i) = Trim$(cargo(i))
    Next i
    
    statusText.Caption = statusText.Caption & "."
    DoEvents
    
    'Generate hash to nickname infos
    Dim hashPath As String
    Dim hashMap As Variant
    hashMap = Array()
    'Process countermeasure data
    Open App.Path & "\Ioncross Hashcodes\GAMEDATA_countermeasures.txt" For Input As #1
    inFile = Input$(LOF(1), 1)
    Close #1
    Dim tmpInArr() As String
    tmpInArr = Split(inFile, vbCrLf)
    For i = LBound(tmpInArr) To UBound(tmpInArr)
        If LenB(Trim$(tmpInArr(i))) <> 0 Then
            tmpInArr(i) = Left$(tmpInArr(i), InStr(tmpInArr(i), ",") - 1) 'Trim infocard name
            Dim tmpVar() As String
            tmpVar = Split(tmpInArr(i), "=")
            tmpVar(LBound(tmpVar)) = Trim$(tmpVar(LBound(tmpVar)))
            tmpVar(UBound(tmpVar)) = Trim$(tmpVar(UBound(tmpVar))) & "_npc"
            ReDim Preserve hashMap(0 To UBound(hashMap) + 1)
            hashMap(UBound(hashMap)) = tmpVar
        End If
    Next i
    DoEvents
    'Process scanner data
    Open App.Path & "\Ioncross Hashcodes\GAMEDATA_scanners.txt" For Input As #1
    inFile = Input$(LOF(1), 1)
    Close #1
    tmpInArr = Split(inFile, vbCrLf)
    For i = LBound(tmpInArr) To UBound(tmpInArr)
        If LenB(Trim(tmpInArr(i))) <> 0 Then
            tmpInArr(i) = Left$(tmpInArr(i), InStr(tmpInArr(i), ",") - 1) 'Trim infocard name
            tmpVar = Split(tmpInArr(i), "=")
            tmpVar(LBound(tmpVar)) = Trim$(tmpVar(LBound(tmpVar)))
            tmpVar(UBound(tmpVar)) = Trim$(tmpVar(UBound(tmpVar))) & "_npc"
            ReDim Preserve hashMap(0 To UBound(hashMap) + 1)
            hashMap(UBound(hashMap)) = tmpVar
        End If
    Next i
    DoEvents
    'Process powergen data
    Open App.Path & "\Ioncross Hashcodes\GAMEDATA_powergenerators.txt" For Input As #1
    inFile = Input$(LOF(1), 1)
    Close #1
    tmpInArr = Split(inFile, vbCrLf)
    For i = LBound(tmpInArr) To UBound(tmpInArr)
        If LenB(Trim(tmpInArr(i))) <> 0 Then
            tmpInArr(i) = Left$(tmpInArr(i), InStr(tmpInArr(i), ",") - 1) 'Trim infocard name
            tmpVar = Split(tmpInArr(i), "=")
            tmpVar(LBound(tmpVar)) = Trim$(tmpVar(LBound(tmpVar)))
            tmpVar(UBound(tmpVar)) = "infinite_power"
            ReDim Preserve hashMap(0 To UBound(hashMap) + 1)
            hashMap(UBound(hashMap)) = tmpVar
        End If
    Next i
    DoEvents
    'Process ship data
    Open App.Path & "\Ioncross Hashcodes\GAMEDATA_ships.txt" For Input As #1
    inFile = Input$(LOF(1), 1)
    Close #1
    Dim shipHashMap As Variant
    shipHashMap = Array()
    tmpInArr = Split(inFile, vbCrLf)
    For i = LBound(tmpInArr) To UBound(tmpInArr)
        If LenB(Trim(tmpInArr(i))) <> 0 Then
            tmpInArr(i) = Left$(tmpInArr(i), InStr(tmpInArr(i), ",") - 1) 'Trim infocard name
            tmpVar = Split(tmpInArr(i), "=")
            tmpVar(LBound(tmpVar)) = Trim$(tmpVar(LBound(tmpVar)))
            tmpVar(UBound(tmpVar)) = Trim$(tmpVar(UBound(tmpVar)))
            ReDim Preserve shipHashMap(0 To UBound(shipHashMap) + 1)
            shipHashMap(UBound(shipHashMap)) = tmpVar
        End If
    Next i
    statusText.Caption = statusText.Caption & "."
    DoEvents
    'Process everything else
    hashPath = Dir(App.Path & "\Ioncross Hashcodes\GAMEDATA*.txt", vbReadOnly)
    Do While LenB(hashPath) <> 0
        If InStr(hashPath, "bases") = 0 And InStr(hashPath, "factions") = 0 And InStr(hashPath, "mapinfo") = 0 And InStr(hashPath, "power") = 0 And InStr(hashPath, "ships") = 0 And InStr(hashPath, "systems") = 0 And InStr(hashPath, "countermeasure") = 0 And InStr(hashPath, "scanners") = 0 Then
            Open App.Path & "\Ioncross Hashcodes\" & hashPath For Input As #1
            inFile = Input$(LOF(1), 1)
            Close #1
            tmpInArr = Split(inFile, vbCrLf)
            For i = LBound(tmpInArr) To UBound(tmpInArr)
                If LenB(Trim(tmpInArr(i))) <> 0 Then
                    tmpInArr(i) = Left$(tmpInArr(i), InStr(tmpInArr(i), ",") - 1) 'Trim infocard name
                    tmpVar = Split(tmpInArr(i), "=")
                    tmpVar(LBound(tmpVar)) = Trim$(tmpVar(LBound(tmpVar)))
                    tmpVar(UBound(tmpVar)) = Trim$(tmpVar(UBound(tmpVar)))
                    ReDim Preserve hashMap(0 To UBound(hashMap) + 1)
                    hashMap(UBound(hashMap)) = tmpVar
                End If
            Next i
        End If
        hashPath = Dir
        DoEvents
    Loop
    
    statusText.Caption = statusText.Caption & "."
    DoEvents

    'Make output string and write it
    Open App.Path & "\data\custom_bot_loadouts.ini" For Input As #1
    inFile = Input$(LOF(1), 1)
    Close #1
    Dim firstBotLoadout As String, botLoadout As String, lastBotLoadout As String
    Dim firstBot As Boolean
    firstBot = True
    Dim botLoadoutIn() As String
    botLoadoutIn = Split(inFile, vbCrLf)
    For i = LBound(botLoadoutIn) To UBound(botLoadoutIn) 'Split the input into two strings and append them to either side of update
        If InStr(botLoadoutIn(i), "Bot_CustomSlot" & botNum.ListIndex + 1 & "_Loadout") <> 0 Then
            firstBot = False
            'Capture line
            If LenB(firstBotLoadout) <> 0 Then
                firstBotLoadout = firstBotLoadout & vbCrLf & botLoadoutIn(i)
            Else
                firstBotLoadout = botLoadoutIn(i)
            End If
            Do While LenB(Trim$(botLoadoutIn(i))) <> 0
                i = i + 1
            Loop
        End If
        If firstBot Then
            If LenB(firstBotLoadout) <> 0 Then
                firstBotLoadout = firstBotLoadout & vbCrLf & botLoadoutIn(i)
            Else
                firstBotLoadout = botLoadoutIn(i)
            End If
        Else
            If LenB(lastBotLoadout) <> 0 Then
                lastBotLoadout = lastBotLoadout & vbCrLf & botLoadoutIn(i)
            Else
                lastBotLoadout = botLoadoutIn(i)
            End If
        End If
    Next i
    DoEvents
    For i = LBound(shipHashMap) To UBound(shipHashMap)
        ship_archetype = Replace$(ship_archetype, shipHashMap(i)(LBound(shipHashMap(i))), shipHashMap(i)(UBound(shipHashMap(i))))
    Next i
    DoEvents
    botLoadout = vbCrLf & "archetype = Bot_CustomSlot" & botNum.ListIndex + 1 & "_Ship" & vbCrLf & ";equip = AI_DBG_TGT_gun, HpMount" & vbCrLf & Join(equip, vbCrLf) & vbCrLf & Join(cargo, vbCrLf) & vbCrLf & vbCrLf
    For i = LBound(hashMap) To UBound(hashMap)
        botLoadout = Replace$(botLoadout, hashMap(i)(LBound(hashMap(i))), hashMap(i)(UBound(hashMap(i))))
    Next i
    DoEvents
    Dim cloakLoc As Long
    cloakLoc = InStr(botLoadout, "_cloak")
    If cloakLoc <> 0 Then 'Comment out cloaking device
        cloakLoc = InStrRev(botLoadout, "equip", cloakLoc)
        botLoadout = Left$(botLoadout, cloakLoc - 1) & Replace$(botLoadout, "equip", ";equip", cloakLoc, 1)
    End If
    'MsgBox Dir(App.Path & "\data", vbDirectory And vbVolume) & "\custom_bot_loadouts.ini"
    Set file = fs.GetFile(App.Path & "\data\custom_bot_loadouts.ini")
    file.Attributes = 0
    Open App.Path & "\data\custom_bot_loadouts.ini" For Output As #1
    'Open App.Path & "\custom_bot_loadouts.ini" For Append As #1
    Print #1, ridCrLf(firstBotLoadout & botLoadout & lastBotLoadout);
    Close #1
    
    statusText.Caption = statusText.Caption & "."
    DoEvents
    
    rank = Replace$(rank, "rank", "level")
    rank = Replace$(rank, "= ", "= d")
    Dim firstNPCShip As Boolean
    Dim firstNPCShipArch, lastNPCShipArch As String
    Open App.Path & "\data\missions\npcships.ini" For Input As #1
    inFile = Input$(LOF(1), 1)
    Close #1
    Dim NPCShipArchIn() As String
    NPCShipArchIn = Split(inFile, vbCrLf)
    firstBot = True
    For i = LBound(NPCShipArchIn) To UBound(NPCShipArchIn) 'Split the input into two strings and append them to either side of update
        If InStr(NPCShipArchIn(i), "Bot_CustomSlot" & botNum.ListIndex + 1 & "_Loadout") <> 0 Then
            firstBot = False
            'Capture line
            If LenB(firstNPCShipArch) <> 0 Then
                firstNPCShipArch = firstNPCShipArch & vbCrLf & NPCShipArchIn(i)
            Else
                firstNPCShipArch = NPCShipArchIn(i)
            End If
            Do While LenB(Trim(NPCShipArchIn(i))) <> 0
                i = i + 1
            Loop
        End If
        If firstBot Then
            If LenB(firstNPCShipArch) <> 0 Then
                firstNPCShipArch = firstNPCShipArch & vbCrLf & NPCShipArchIn(i)
            Else
                firstNPCShipArch = NPCShipArchIn(i)
            End If
        Else
            If LenB(lastNPCShipArch) <> 0 Then
                lastNPCShipArch = lastNPCShipArch & vbCrLf & NPCShipArchIn(i)
            Else
                lastNPCShipArch = NPCShipArchIn(i)
            End If
        End If
    Next i
    DoEvents
    'Pilot settings generation
    Dim NPCShipArch As String, pilot As String, state_graph As String
    Open App.Path & "\Ioncross Hashcodes\GAMEDATA_engines.txt" For Input As #1
    inFile = Input$(LOF(1), 1)
    Close #1
    tmpInArr = Split(inFile, vbCrLf)
    For i = LBound(tmpInArr) To UBound(tmpInArr)
        If LenB(Trim$(tmpInArr(i))) <> 0 Then
            tmpInArr(i) = Trim$(Right$(tmpInArr(i), Len(tmpInArr(i)) - InStr(tmpInArr(i), "=") - 1)) 'Get everything right of the "="
            tmpVar = Split(tmpInArr(i), ",")
            tmpVar(UBound(tmpVar)) = Trim$(tmpVar(UBound(tmpVar)))
            tmpVar(LBound(tmpVar)) = Trim$(tmpVar(LBound(tmpVar)))
            If InStr(botLoadout, tmpVar(LBound(tmpVar))) <> 0 Then
                If InStr(tmpVar(UBound(tmpVar)), "Cruiser") <> 0 Or InStr(tmpVar(UBound(tmpVar)), "Destroyer") <> 0 Or InStr(tmpVar(UBound(tmpVar)), "Gunboat") <> 0 Or InStr(tmpVar(UBound(tmpVar)), "Battleship") <> 0 Or InStr(tmpVar(UBound(tmpVar)), "Miner") <> 0 Or InStr(tmpVar(UBound(tmpVar)), "Solar") <> 0 Then 'Regular pilot and state_graph
                    pilot = "pilot = pilot_bot_capital"
                    state_graph = "state_graph = FIGHTER"
                Else
                    If InStr(tmpVar(UBound(tmpVar)), "VHF") <> 0 Then
                        pilot = "pilot = pilot_bot_vhf"
                        state_graph = "state_graph = FIGHTER"
                    Else
                        pilot = "pilot = pilot_bot"
                        state_graph = "state_graph = FIGHTER"
                    End If
                End If
            End If
        End If
    Next i
    NPCShipArch = vbCrLf & rank & vbCrLf & "ship_archetype = Bot_CustomSlot" & botNum.ListIndex + 1 & "_Ship" & vbCrLf & pilot & vbCrLf & state_graph & vbCrLf & "npc_class = lawful, class_CustomSlot" & botNum.ListIndex + 1 & ", d1" & vbCrLf & vbCrLf
    Set file = fs.GetFile(App.Path & "\data\missions\npcships.ini")
    file.Attributes = 0
    Open App.Path & "\data\missions\npcships.ini" For Output As #1
    'Open App.Path & "\npcships.ini" For Append As #1
    Print #1, ridCrLf(firstNPCShipArch & NPCShipArch & lastNPCShipArch);
    Close #1
    
    statusText.Caption = statusText.Caption & "."
    DoEvents
    
    'Generate stuffs for bot name generation (Get info from shiparch.ini, dump into custom_bot_ships.ini with modifications.
    'replace ids_name = (number) with ids_name = 0 ;GENERATESTRRES("name here")
    'change nickname = <original ship nick> to nickname = Bot_CustomSlot#_Ship
    'change "type = FREIGHTER" to "type = CAPITAL"
    'Also comment out any lines with "_cloak" in them
    ship_archetype = Trim$(Right$(ship_archetype, Len(ship_archetype) - InStr(ship_archetype, "=")))
    Dim FLShipArch() As String
    Open App.Path & "\data\ships\shiparch.ini" For Input As #1
    FLShipArch = Split(Input$(LOF(1), 1), vbCrLf)
    Close #1
    Dim firstIndex As Long, lastIndex As Long
    For i = LBound(FLShipArch) To UBound(FLShipArch) 'Find ship entry
        If InStr(FLShipArch(i), "nickname") <> 0 Then
            If Trim$(Mid$(FLShipArch(i), InStr(FLShipArch(i), "=") + 1)) = ship_archetype Then
                Do While i <> LBound(FLShipArch) And InStr(FLShipArch(i), "[ship]") = 0
                    i = i - 1
                Loop
                firstIndex = i
                Do While i <> UBound(FLShipArch) And LenB(Trim$(FLShipArch(i))) <> 0
                    i = i + 1
                Loop
                lastIndex = i
                Exit For
            End If
        End If
    Next i
    For i = firstIndex To lastIndex
        FLShipArch(i) = Replace$(FLShipArch(i), "death_comm_player", "death_comm_bot")
        If InStr(FLShipArch(i), "ids_name") = 1 Then
            FLShipArch(i) = "ids_name = 0 ;GENERATESTRRES(""" & NameTxt.Text & """)"
        Else
            If InStr(FLShipArch(i), "type") = 1 Then
                FLShipArch(i) = "type = FREIGHTER" & vbCrLf & "AIBot = true"
            Else
                If InStr(FLShipArch(i), "nickname") <> 0 Then
                    FLShipArch(i) = "nickname = Bot_CustomSlot" & botNum.ListIndex + 1 & "_Ship"
                End If
            End If
        End If
    Next i
    statusText.Caption = statusText.Caption & "."
    DoEvents
    Dim ShipArch As String
    For i = firstIndex To lastIndex
        If i <> lastIndex Then
            ShipArch = ShipArch & FLShipArch(i) & vbCrLf
        Else
            ShipArch = ShipArch & FLShipArch(i)
        End If
    Next i
    Dim botShipArch As String
    Open App.Path & "\data\custom_bot_ships.ini" For Input As #1
    botShipArch = Input$(LOF(1), 1)
    Close #1
    Dim numFound As Long
    Dim replaceindex As Long
    replaceindex = 1
    numFound = 1
    replaceindex = InStr(replaceindex, botShipArch, "[ship]")
    Do While numFound <> botNum.ListIndex + 1
        replaceindex = InStr(replaceindex + 6, botShipArch, "[ship]")
        numFound = numFound + 1
    Loop
    Dim firstBotShipArch As String, lastBotShipArch As String
    firstBotShipArch = Left$(botShipArch, replaceindex - 1)
    replaceindex = InStr(replaceindex + 6, botShipArch, "[ship]") - 1
    If replaceindex < 1 Then replaceindex = Len(botShipArch)
    lastBotShipArch = Right$(botShipArch, Len(botShipArch) - replaceindex)
    If botNum.ListIndex = 3 Then
        Do While InStrRev(ShipArch, vbCrLf) + 1 = Len(ShipArch)
            ShipArch = Left$(ShipArch, Len(ShipArch) - 2)
        Loop
        lastBotShipArch = ""
    Else
        Do While InStrRev(lastBotShipArch, vbCrLf) + 1 = Len(lastBotShipArch)
            lastBotShipArch = Left$(lastBotShipArch, Len(lastBotShipArch) - 2)
        Loop
        lastBotShipArch = vbCrLf & lastBotShipArch
    End If
    Set file = fs.GetFile(App.Path & "\data\custom_bot_ships.ini")
    file.Attributes = 0
    Open App.Path & "\data\custom_bot_ships.ini" For Output As #1
    Print #1, firstBotShipArch & Trim$(ShipArch) & lastBotShipArch;
    Close #1
    
    statusText.Caption = "Ready"
    GenButton.Enabled = True
    botNum.ListIndex = -1
    botNum.Text = "Bot #"
    botNum.Enabled = True
    setDir.Enabled = True
    NameTxt.Enabled = True
    List1.ListIndex = -1
    List1.Enabled = True
    NameTxt.Text = "Name"
    Set fs = Nothing
    Set file = Nothing
    DoEvents
End Function

Public Function ridCrLf(inString As String) As String
    Do While InStrRev(inString, vbCrLf) + 1 = Len(inString)
        inString = Left$(inString, Len(inString) - 2)
    Loop
    ridCrLf = inString
End Function

'Credits to Sherlog <sherlog@t-online.de> for finding out the algorithm
'Rewritten from C
Public Function FLCDecode(strCharFilename As String, strOut As String) As Boolean

     Dim Gene(0 To 3) As Byte
     Gene(0) = &H47 'G
     Gene(1) = &H65 'e
     Gene(2) = &H6E 'n
     Gene(3) = &H65 'e
     Dim out() As Byte
     Dim playerBytes() As Byte
     Dim fileLength As Long
     Dim iFileNo As Integer
     iFileNo = FreeFile()
     Open strCharFilename For Binary As #iFileNo
     Dim strFile As String
     strFile = Input$(4, iFileNo)
     If strFile <> "FLS1" Then 'Charfile not encoded
        strOut = strFile & Input$(LOF(iFileNo) - 4, iFileNo)
        Close #iFileNo
        FLCDecode = False
        Exit Function
     End If
     fileLength = LOF(iFileNo)
     ReDim playerBytes(0 To fileLength - 1)
     ReDim out(0 To (fileLength - 5) * 2 + 1)
     Get #iFileNo, 1, playerBytes
     Close #iFileNo
     
     Dim i As Long, l As Long
     i = 0
     l = fileLength - 4
    
     Do While i < l
       Dim c As Byte, k As Byte, r As Byte
       c = playerBytes(i + 4)
       k = (Gene(i Mod 4) + i) Mod 256
    
       r = c Xor (k Or &H80)
       
       out(i * 2) = r
       i = i + 1
     Loop
     
     strOut = out
 
    FLCDecode = True
End Function

Private Function GetSpecialFolderLocation(CSIDL As Long) As String

   Dim sPath As String
   Dim pidl As Long
   
  'fill the idl structure with the specified folder item
   If SHGetSpecialFolderLocation(Me.hWnd, CSIDL, pidl) = S_OK Then
     
     'if the pidl is returned, initialize
     'and get the path from the id list
      sPath = Space$(MAX_PATH)
      
      If SHGetPathFromIDList(ByVal pidl, ByVal sPath) Then

        'return the path
         GetSpecialFolderLocation = Left(sPath, InStr(sPath, Chr$(0)) - 1)
         
      End If
    
     'free the pidl
      Call CoTaskMemFree(pidl)

    End If
   
End Function

Private Sub List1_Click()
    If List1.ListIndex <> -1 Then NameTxt.Text = chars(List1.ListIndex).Name
End Sub

Private Sub setDir_Click()
    Dim newPath As String
    newPath = GetFolder(Me.hWnd, "Select Directory of FL save games")
    If newPath = "" Then Exit Sub 'User canceled
    pathText.Text = newPath
    
    List1.Clear
    Erase chars
    Dim subFolders As Variant
    statusText.Caption = "Looking for subfolders in " & pathText.Text
    DoEvents
    subFolders = getSubFolders(pathText.Text)
    ReDim Preserve subFolders(LBound(subFolders) To UBound(subFolders) + 1)
    subFolders(UBound(subFolders)) = pathText.Text
    Dim i As Integer
    For i = LBound(subFolders) To UBound(subFolders)
        Dim status As String
        status = Replace(subFolders(i), pathText.Text, "")
        If status = "" Then status = "root directory"
        statusText.Caption = "Looking for character files in " & status
        DoEvents
        Dim charPath As String
        charPath = Dir(subFolders(i) & "\*.fl", vbReadOnly)
        Do While charPath <> ""
            Dim char As charFile
            char.Path = subFolders(i) & "\" & charPath
            char.Name = getCharName(char.Path)
            If char.Name <> "" Then
                If (Not chars) = -1 Then
                    ReDim chars(0 To 0)
                Else
                    ReDim Preserve chars(LBound(chars) To UBound(chars) + 1)
                End If
                chars(UBound(chars)) = char
            End If
            charPath = Dir
        Loop
    Next i
    
    If (Not chars) <> -1 Then
        For i = LBound(chars) To UBound(chars)
            List1.AddItem (chars(i).Name)
        Next i
    End If
    statusText.Caption = "Ready"
End Sub

Private Sub GenButton_Click()
    If List1.ListIndex = -1 Or botNum.ListIndex = -1 Then
        MsgBox "Select a file to convert and a bot number to convert to.", vbCritical, "Error"
    Else
        statusText.Caption = "Generating bot from " & chars(List1.ListIndex).Name
        processFile (chars(List1.ListIndex).Path)
    End If
End Sub

'Private Sub testDecode_Click()
'    If List1.ListIndex = -1 Or botNum.ListIndex = -1 Then
'        MsgBox "Select a file to convert and a bot number to convert to.", vbCritical, "Error"
'    Else
'        MsgBox DecodeFile(chars(List1.ListIndex).Path)
'    End If
'End Sub
